## mingw-w64-qt6-graphs-6.10.0-1.src.tar.zst

=== src/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_feature_evaluate_features("${CMAKE_CURRENT_SOURCE_DIR}/configure.cmake")

set(QT_SBOM_DEFAULT_QT_LICENSE_ID_LIBRARIES "QT_COMMERCIAL_OR_GPL3")

if(NOT QT_FEATURE_graphs_2d AND NOT QT_FEATURE_graphs_3d)
    message("You must have either FEATURE_graphs_2d or FEATURE_graphs_3d ON, or nothing will be built.")
else()
    # 2D specific resources
    set(shader_resource_files_2D
        "graphs2d/data/gridshader.frag.qsb"
        "graphs2d/data/gridshader.vert.qsb"
        "graphs2d/data/tickershader.frag.qsb"
        "graphs2d/data/tickershader.vert.qsb"
        "graphs2d/data/tickershaderhorizontal.frag.qsb"
        "graphs2d/data/tickershaderhorizontal.vert.qsb"
        "graphs2d/data/lineshaderhorizontal.frag.qsb"
        "graphs2d/data/lineshaderhorizontal.vert.qsb"
        "graphs2d/data/lineshadervertical.frag.qsb"
        "graphs2d/data/lineshadervertical.vert.qsb"
    )

    set(qml_component_resources
        "graphs3d/qml/resources/DatapointSphere.qml"
        "graphs3d/qml/resources/DatapointCube.qml"
    )

    foreach(file IN LISTS qml_component_resources)
        get_filename_component(filename ${file} NAME)
        set(RESOURCE_NAME ${filename})
        string(REPLACE ".qml" "" RESOURCE_NAME ${RESOURCE_NAME})
        set_source_files_properties(${file} PROPERTIES QT_RESOURCE_ALIAS ${RESOURCE_NAME})
    endforeach()

    set(qml_axis_resources
        "graphs3d/qml/resources/AxisLabel.qml"
        "graphs3d/qml/resources/GridLine.qml"
        "graphs3d/qml/resources/ItemLabel.qml"
        "graphs3d/qml/resources/TitleLabel.qml"
    )

    foreach(file IN LISTS qml_axis_resources)
        get_filename_component(filename ${file} NAME)
        set(RESOURCE_NAME ${filename})
        string(REPLACE ".qml" "" RESOURCE_NAME ${RESOURCE_NAME})
        set_source_files_properties(${file} PROPERTIES QT_RESOURCE_ALIAS ${RESOURCE_NAME})
    endforeach()

    set(qml_material_resources
        "graphs3d/qml/resources/ObjectGradientMaterial.qml"
        "graphs3d/qml/resources/ObjectGradientMaterialInstancing.qml"
        "graphs3d/qml/resources/BarsMaterial.qml"
        "graphs3d/qml/resources/BarsMaterialInstancing.qml"
        "graphs3d/qml/resources/SurfaceMaterial.qml"
        "graphs3d/qml/resources/ScatterMaterial.qml"
        "graphs3d/qml/resources/ScatterMaterialInstancing.qml"
        "graphs3d/qml/resources/SplineMaterial.qml"
        "graphs3d/qml/resources/GridSurfaceMaterial.qml"
        "graphs3d/qml/resources/SurfaceSliceMaterial.qml"
        "graphs3d/qml/resources/SurfaceShadowNoTex.qml"
        "graphs3d/qml/resources/VolumeMaterial.qml"
        "graphs3d/qml/resources/VolumeLowDefMaterial.qml"
        "graphs3d/qml/resources/VolumeSliceMaterial.qml"
        "graphs3d/qml/resources/VolumeFrameMaterial.qml"
        "graphs3d/qml/resources/BackgroundMaterial.qml"
    )

    foreach(file IN LISTS qml_material_resources)
        get_filename_component(filename ${file} NAME)
        set(RESOURCE_NAME ${filename})
        string(REPLACE ".qml" "" RESOURCE_NAME ${RESOURCE_NAME})
        set_source_files_properties(${file} PROPERTIES QT_RESOURCE_ALIAS ${RESOURCE_NAME})
    endforeach()

    set(resources
        "graphs2d/qml/designer/Graphs.metainfo"
        "graphs2d/qml/designer/images/bars3d-icon.png"
        "graphs2d/qml/designer/images/bars3d-icon16.png"
        "graphs2d/qml/designer/images/scatter3d-icon.png"
        "graphs2d/qml/designer/images/scatter3d-icon16.png"
        "graphs2d/qml/designer/images/surface3d-icon.png"
        "graphs2d/qml/designer/images/surface3d-icon16.png"
    )

    set(mesh_resource_files
        "graphs3d/engine/meshes/backgroundMesh.mesh"
        "graphs3d/engine/meshes/backgroundNoFloorMesh.mesh"
        "graphs3d/engine/meshes/arrowMesh.mesh"
        "graphs3d/engine/meshes/arrowMeshSmooth.mesh"
        "graphs3d/engine/meshes/bevelBarMeshFull.mesh"
        "graphs3d/engine/meshes/bevelBarMeshSmoothFull.mesh"
        "graphs3d/engine/meshes/bevelBarMesh.mesh"
        "graphs3d/engine/meshes/bevelBarMeshSmooth.mesh"
        "graphs3d/engine/meshes/coneMeshFull.mesh"
        "graphs3d/engine/meshes/coneMeshSmoothFull.mesh"
        "graphs3d/engine/meshes/coneMesh.mesh"
        "graphs3d/engine/meshes/coneMeshSmooth.mesh"
        "graphs3d/engine/meshes/barMeshFull.mesh"
        "graphs3d/engine/meshes/barMeshSmoothFull.mesh"
        "graphs3d/engine/meshes/barMesh.mesh"
        "graphs3d/engine/meshes/barMeshSmooth.mesh"
        "graphs3d/engine/meshes/cylinderMeshFull.mesh"
        "graphs3d/engine/meshes/cylinderMeshSmoothFull.mesh"
        "graphs3d/engine/meshes/cylinderMesh.mesh"
        "graphs3d/engine/meshes/cylinderMeshSmooth.mesh"
        "graphs3d/engine/meshes/minimalMesh.mesh"
        "graphs3d/engine/meshes/minimalMeshSmooth.mesh"
        "graphs3d/engine/meshes/planeMesh.mesh"
        "graphs3d/engine/meshes/pyramidMeshFull.mesh"
        "graphs3d/engine/meshes/pyramidMeshSmoothFull.mesh"
        "graphs3d/engine/meshes/pyramidMesh.mesh"
        "graphs3d/engine/meshes/pyramidMeshSmooth.mesh"
        "graphs3d/engine/meshes/octagonMesh.mesh"
        "graphs3d/engine/meshes/sphereMesh.mesh"
        "graphs3d/engine/meshes/sphereMeshSmooth.mesh"
    )

    foreach(file IN LISTS mesh_resource_files)
        get_filename_component(filename ${file} NAME)
        set(RESOURCE_NAME ${filename})
        string(REPLACE ".mesh" "" RESOURCE_NAME ${RESOURCE_NAME})
        set_source_files_properties(${file} PROPERTIES QT_RESOURCE_ALIAS ${RESOURCE_NAME})
    endforeach()

    set(shader_resource_files
        "graphs3d/engine/shaders/3dsliceframes.frag"
        "graphs3d/engine/shaders/position.vert"
        "graphs3d/engine/shaders/objectgradient.vert"
        "graphs3d/engine/shaders/objectgradient.frag"
        "graphs3d/engine/shaders/objectgradientinstancing.vert"
        "graphs3d/engine/shaders/objectgradientinstancing.frag"
        "graphs3d/engine/shaders/rangegradient.frag"
        "graphs3d/engine/shaders/rangegradientinstancing.frag"
        "graphs3d/engine/shaders/surface.vert"
        "graphs3d/engine/shaders/surface.frag"
        "graphs3d/engine/shaders/surfaceGrid.vert"
        "graphs3d/engine/shaders/surfaceGrid.frag"
        "graphs3d/engine/shaders/bars.frag"
        "graphs3d/engine/shaders/barsinstancing.vert"
        "graphs3d/engine/shaders/barsinstancing.frag"
        "graphs3d/engine/shaders/scatter.vert"
        "graphs3d/engine/shaders/scatter.frag"
        "graphs3d/engine/shaders/scatterinstancing.vert"
        "graphs3d/engine/shaders/scatterinstancing.frag"
        "graphs3d/engine/shaders/surfaceSlice.vert"
        "graphs3d/engine/shaders/spline.vert"
        "graphs3d/engine/shaders/spline.frag"
        "graphs3d/engine/shaders/texture3d.frag"
        "graphs3d/engine/shaders/texture3d.vert"
        "graphs3d/engine/shaders/texture3dlowdef.frag"
        "graphs3d/engine/shaders/texture3dslice.frag"
        "graphs3d/engine/shaders/backgroundgrid.frag"
    )

    foreach(file IN LISTS shader_resource_files)
        get_filename_component(filename ${file} NAME)
        set(RESOURCE_NAME ${filename})
        string(REPLACE "." "" RESOURCE_NAME ${RESOURCE_NAME})
        set_source_files_properties(${file} PROPERTIES QT_RESOURCE_ALIAS ${RESOURCE_NAME})
    endforeach()

    # First check if both 2D and 3D are enabled. If it is, we must add dependencies to
    # both (i.e. QtQuick3D, Quick3DPrivate, Quick3DRuntimeRenderPrivate,
    # QtQuickPrivate, and QtQuickShapesPrivate).
    if(QT_FEATURE_graphs_3d AND QT_FEATURE_graphs_2d)
        qt_internal_add_qml_module(Graphs
            URI "QtGraphs"
            TARGET_PRODUCT "Qt Graphs (Qt $$QT_VERSION)"
            TARGET_DESCRIPTION "Qt Graphs Visualization component for Qt."
            VERSION "${PROJECT_VERSION}"
            PAST_MAJOR_VERSIONS 1
            DEPENDENCIES
                QtQuick
                # 3D specific
                QtQuick3D
            LIBRARIES
                # Common
                Qt::CorePrivate
                Qt::QuickPrivate
                # 2D specific
                Qt::QuickShapesPrivate
                # 3D specific
                Qt::Quick3DPrivate
                Qt::Quick3DRuntimeRenderPrivate
            PUBLIC_LIBRARIES
                Qt::Core
                Qt::Gui
                Qt::Quick
                Qt::Quick3D
            PRIVATE_MODULE_INTERFACE
                # Common
                Qt::CorePrivate
                Qt::QuickPrivate
                # 3D specific
                Qt::Quick3DPrivate
                Qt::Quick3DRuntimeRenderPrivate
        )

        # CMake 3.16 forces these to be added here instead of the graphs3d folder
         qt_internal_add_resource(Graphs "graphsshaders2D"
            PREFIX
                "/shaders"
            BASE
                "graphs2d/data"
            FILES
                ${shader_resource_files_2D}
        )

        qt_internal_add_resource(Graphs "graphsshaders"
            PREFIX
                "/shaders"
            BASE
                "graphs3d/engine/shaders"
            FILES
                ${shader_resource_files}
        )

        qt_internal_add_resource(Graphs "graphsmeshes"
            PREFIX
                "/defaultMeshes"
            BASE
                "graphs3d/engine/meshes"
            FILES
                ${mesh_resource_files}
                ${obj_resource_files}
        )

        qt_internal_add_resource(Graphs "qml_component_resources"
            PREFIX
                "/datapointModels"
            BASE
                "graphs3d/qml"
            FILES
                ${qml_component_resources}
        )

        qt_internal_add_resource(Graphs "qml_axis_resources"
            PREFIX
                "/axis"
            BASE
                "graphs3d/qml"
            FILES
                ${qml_axis_resources}
        )

        qt_internal_add_resource(Graphs "qml_material_resources"
            PREFIX
                "/materials"
            BASE
                "graphs3d/qml"
            FILES
                ${qml_material_resources}
        )
    else()
        if(QT_FEATURE_graphs_3d)
            qt_internal_add_qml_module(Graphs
                URI "QtGraphs"
                TARGET_PRODUCT "Qt Graphs (Qt $$QT_VERSION)"
                TARGET_DESCRIPTION "Qt Graphs Visualization component for Qt."
                VERSION "${PROJECT_VERSION}"
                PAST_MAJOR_VERSIONS 1
                DEPENDENCIES
                    QtQuick
                    QtQuick3D
                LIBRARIES
                    Qt::QuickPrivate
                    Qt::Quick3DPrivate
                    Qt::Quick3DRuntimeRenderPrivate
                PUBLIC_LIBRARIES
                    Qt::Core
                    Qt::Gui
                    Qt::Quick
                    Qt::Quick3D
                PRIVATE_MODULE_INTERFACE
                    Qt::QuickPrivate
                    Qt::Quick3DPrivate
                    Qt::Quick3DRuntimeRenderPrivate
            )

            # CMake 3.16 forces these to be added here instead of the graphs3d folder
            qt_internal_add_resource(Graphs "graphsshaders"
                PREFIX
                    "/shaders"
                BASE
                    "graphs3d/engine/shaders"
                FILES
                    ${shader_resource_files}
            )

            qt_internal_add_resource(Graphs "graphsmeshes"
                PREFIX
                    "/defaultMeshes"
                BASE
                    "graphs3d/engine/meshes"
                FILES
                    ${mesh_resource_files}
                    ${obj_resource_files}
            )

            qt_internal_add_resource(Graphs "qml_component_resources"
                PREFIX
                    "/datapointModels"
                BASE
                    "graphs3d/qml"
                FILES

=== src/graphs3d/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_configure_add_summary_section(NAME "Qt Graphs 3D")
qt_configure_add_summary_entry(ARGS "graphs-3d-bars3d")
qt_configure_add_summary_entry(ARGS "graphs-3d-scatter3d")
qt_configure_add_summary_entry(ARGS "graphs-3d-surface3d")
qt_configure_end_summary_section() # end of "Qt Graphs 3D" section

if(NOT QT_FEATURE_graphs_3d_bars3d AND NOT QT_FEATURE_graphs_3d_scatter3d AND NOT QT_FEATURE_graphs_3d_surface3d)
    message("You must have either FEATURE_graphs_3d_bars3d, FEATURE_graphs_3d_scatter3d, or FEATURE_graphs_3d_surface3d ON, or nothing will be built.")
else()
    qt_internal_extend_target(Graphs
        SOURCES
            axis/qabstract3daxis.cpp axis/qabstract3daxis.h axis/qabstract3daxis_p.h
            axis/qcategory3daxis.cpp axis/qcategory3daxis.h axis/qcategory3daxis_p.h
            axis/qlogvalue3daxisformatter.cpp axis/qlogvalue3daxisformatter.h axis/qlogvalue3daxisformatter_p.h
            axis/qvalue3daxis.cpp axis/qvalue3daxis.h axis/qvalue3daxis_p.h
            axis/qvalue3daxisformatter.cpp axis/qvalue3daxisformatter.h axis/qvalue3daxisformatter_p.h

            data/abstractitemmodelhandler.cpp data/abstractitemmodelhandler_p.h
            data/qabstract3dseries.cpp data/qabstract3dseries.h data/qabstract3dseries_p.h
            data/qabstractdataproxy.cpp data/qabstractdataproxy.h data/qabstractdataproxy_p.h
            data/qcustom3ditem.cpp data/qcustom3ditem.h data/qcustom3ditem_p.h
            data/qcustom3dlabel.cpp data/qcustom3dlabel.h data/qcustom3dlabel_p.h
            data/qcustom3dvolume.cpp data/qcustom3dvolume.h data/qcustom3dvolume_p.h

            engine/q3dscene.cpp engine/q3dscene.h engine/q3dscene_p.h

            input/qgraphsinputhandler.cpp  input/qgraphsinputhandler_p.h

            utils/qutils.h
            utils/utils.cpp utils/utils_p.h
            utils/qgraphs3dnamespace.cpp utils/qgraphs3dnamespace.h
            utils/qgraphs3dlogging.cpp utils/qgraphs3dlogging_p.h

            qml/qquickgraphsitem.cpp qml/qquickgraphsitem_p.h
            qml/qquickgraphsnode.cpp qml/qquickgraphsnode_p.h

            qml/qquickgraphstexturedata.cpp qml/qquickgraphstexturedata_p.h
            qml/gradientholder_p.h
        INCLUDE_DIRECTORIES
            axis
            data
            engine
            input
            utils
            qml
            ../common/utils/
    )

    qt_internal_extend_target(Graphs CONDITION QT_FEATURE_graphs_3d_bars3d
        SOURCES
            data/baritemmodelhandler.cpp data/baritemmodelhandler_p.h
            data/qbar3dseries.cpp data/qbar3dseries.h data/qbar3dseries_p.h
            data/qbardataitem.cpp data/qbardataitem.h
            data/qbardataproxy.cpp data/qbardataproxy.h data/qbardataproxy_p.h
            data/qitemmodelbardataproxy.cpp data/qitemmodelbardataproxy.h data/qitemmodelbardataproxy_p.h

            engine/barinstancing.cpp engine/barinstancing_p.h

            qml/qquickgraphsbars.cpp qml/qquickgraphsbars_p.h
            qml/qquickgraphsbarsnode.cpp qml/qquickgraphsbarsnode_p.h
            qml/qquickgraphsbarsseries.cpp qml/qquickgraphsbarsseries_p.h
        INCLUDE_DIRECTORIES
            data
            engine
            qml
    )

    qt_internal_extend_target(Graphs CONDITION QT_FEATURE_graphs_3d_scatter3d
        SOURCES
            data/qitemmodelscatterdataproxy.cpp data/qitemmodelscatterdataproxy.h data/qitemmodelscatterdataproxy_p.h
            data/qscatter3dseries.cpp data/qscatter3dseries.h data/qscatter3dseries_p.h
            data/qspline3dseries.cpp data/qspline3dseries.h data/qspline3dseries_p.h
            data/qscatterdataitem.cpp data/qscatterdataitem.h
            data/qscatterdataproxy.cpp data/qscatterdataproxy.h data/qscatterdataproxy_p.h
            data/scatteritemmodelhandler.cpp data/scatteritemmodelhandler_p.h

            engine/scatterinstancing.cpp engine/scatterinstancing_p.h

            qml/qquickgraphsscatter.cpp qml/qquickgraphsscatter_p.h
            qml/qquickgraphsscatternode.cpp qml/qquickgraphsscatternode_p.h
            qml/qquickgraphsscatterseries.cpp qml/qquickgraphsscatterseries_p.h
            qml/qquickgraphssplineseries.cpp qml/qquickgraphssplineseries_p.h
        INCLUDE_DIRECTORIES
            data
            engine
            qml
    )

    qt_internal_extend_target(Graphs CONDITION QT_FEATURE_graphs_3d_surface3d
        SOURCES
            data/qheightmapsurfacedataproxy.cpp data/qheightmapsurfacedataproxy.h data/qheightmapsurfacedataproxy_p.h
            data/qitemmodelsurfacedataproxy.cpp data/qitemmodelsurfacedataproxy.h data/qitemmodelsurfacedataproxy_p.h
            data/qsurface3dseries.cpp data/qsurface3dseries.h data/qsurface3dseries_p.h
            data/qsurfacedataitem.cpp data/qsurfacedataitem.h
            data/qsurfacedataproxy.cpp data/qsurfacedataproxy.h data/qsurfacedataproxy_p.h
            data/surfaceitemmodelhandler.cpp data/surfaceitemmodelhandler_p.h

            qml/qquickgraphssurface.cpp qml/qquickgraphssurface_p.h
            qml/qquickgraphssurfacenode.cpp qml/qquickgraphssurfacenode_p.h
            qml/qquickgraphssurfaceseries.cpp qml/qquickgraphssurfaceseries_p.h
        INCLUDE_DIRECTORIES
            data
            engine
            qml
    )

    qt_internal_extend_target(Graphs CONDITION MACOS
        LIBRARIES
            Qt::GuiPrivate
        PUBLIC_LIBRARIES
            Qt::Gui
        PRIVATE_MODULE_INTERFACE
            Qt::GuiPrivate
    )

    add_subdirectory(qml/designer)

    set(
        LOCAL_TRACE_SOURCES
            graphs3d/qml/qquickgraphsitem.cpp
    )

    if(QT_FEATURE_graphs_3d_surface3d)
        set(
            LOCAL_TRACE_SOURCES
               ${LOCAL_TRACE_SOURCES}
               graphs3d/qml/qquickgraphssurface.cpp
        )
    endif()

    set(
        TRACE_SOURCES
            ${LOCAL_TRACE_SOURCES}
        PARENT_SCOPE
    )
endif()
if(TARGET Qt::Widgets)
    add_subdirectory(widget)
endif()

=== tests/manual/minimalbars/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

if (NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    project(tst_minimalbars LANGUAGES C CXX)
    find_package(Qt6BuildInternals COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_manual_test(tst_minimalbars
    GUI
    SOURCES
        ../../../src/graphs3d/widget/doc/snippets/doc_src_q3dbars_construction.cpp
    )
target_link_libraries(tst_minimalbars PUBLIC
    Qt::Gui
    Qt::Graphs
    Qt::GraphsWidgets
    )

=== tests/manual/qmlrenderslicetoimage/CMakeLists.txt ===
# Copyright (C) 2025 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

if (NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    project(tst_qmlrenderslicetoimage LANGUAGES C CXX)
    find_package(Qt6BuildInternals COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_manual_test(tst_qmlrenderslicetoimage
    GUI
    SOURCES
        main.cpp
    )
target_link_libraries(tst_qmlrenderslicetoimage PUBLIC
    Qt::Gui
    Qt::Graphs
    )

set(qmlrenderslicetoimage_resource_files
    "qml/qmlrenderslicetoimage/main.qml"
    "qml/qmlrenderslicetoimage/SurfaceGraph.qml"
    "qml/qmlrenderslicetoimage/BarGraph.qml"
    )

qt_internal_add_resource(tst_qmlrenderslicetoimage "qmlgrabsliceview"
    PREFIX
    "/"
    FILES
    ${qmlrenderslicetoimage_resource_files}
    )

set(qmlrenderslicetoimage_image_resource_files
    "layer_1.png"
    "layer_2.png"
    "layer_3.png"
)

qt6_add_resources(tst_qmlrenderslicetoimage "qmlsurfacelayers1"
    PREFIX
        "/heightmaps"
    FILES
        ${qmlrenderslicetoimage_image_resource_files}
)

=== tests/auto/cpp2dtest/qgbarmodelmapper/CMakeLists.txt ===
qt_internal_add_test(tst_qgbarmodelmapper2d
    SOURCES
        tst_barmodelmapper.cpp
    INCLUDE_DIRECTORIES
        ../common
    LIBRARIES
        Qt::Gui
        Qt::GuiPrivate
        Qt::Graphs
)

=== tests/auto/cpptest/qgbars-proxy/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_test(tst_qgbars_proxy
    SOURCES
        tst_proxy.cpp
    LIBRARIES
        Qt::Gui
        Qt::Graphs
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-graphs
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.10.0
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt Data Visualization module provides multiple graph types to visualize data in 3D space (mingw-w64)'
arch=(any)
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgraphs.git"
msys2_references=(
  'archlinux: qt6-graphs'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:BSD-3-Clause WITH Qt-GPL-exception-1.0 AND GPL-3.0-only AND GFDL-1.3-no-invariants-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('6ec8f1b3b3bea6636da8846353e170794c76d5833fc908016f911647a6a714ea')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-graphs() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-quick3d")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-graphs-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
